WebClient/Models/DashboardViewModel.cs
using GoC.AppStatus.DBAccess.DBEntities;
using System.Collections.Generic;


namespace GoC.AppStatus.WebClient.Models
{
    public class DashboardViewModel
    {
        public IEnumerable<ServiceViewModel> AllServices { get; set; }
    }
}

WebClient/Controllers/HomeController.cs
using AutoMapper;
using GoC.AppStatus.CheckService.Utilities;
using GoC.AppStatus.DBAccess.DataAccess;
using GoC.AppStatus.WebClient.Configs;
using GoC.AppStatus.WebClient.Models;
using GoC.WebTemplate.Components.Core.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Localization;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Security.Claims;

namespace GoC.AppStatus.WebClient.Controllers
{
    public class HomeController : BaseController
    {
        private readonly IServiceQueries _serviceQueries;
        private readonly ISubscriptionQueries _subscriptionQueries;
        private readonly IEnvironmentQueries _environmentQueries;
        private IServiceQueries ServiceQueries => (IServiceQueries)ConnectDatabaseSQL(_serviceQueries);
        private IEnvironmentQueries EnvironmentQueries => (IEnvironmentQueries)ConnectDatabaseSQL(_environmentQueries);

        public HomeController(ModelAccessor modelAccessor,
                              IMapper mapper,
                              IConfiguration configuration,
                              ILogger<HomeController> logger,
                              IServiceQueries serviceQueries,
                              ISubscriptionQueries subscriptionQueries,
                              IEnvironmentQueries environmentQueries,
                              IStringLocalizer<BaseController> baseLocalizer) :
            base(modelAccessor, mapper, configuration, logger, baseLocalizer)
        {
            _serviceQueries = serviceQueries;
            _subscriptionQueries = subscriptionQueries;
            _environmentQueries = environmentQueries;
        }

        public IActionResult Index()
        {
            if (User.Identity.IsAuthenticated)
            {
                var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
                if (userId > 0)
                {
                    var servicesModel = new DashboardViewModel
                    {
                        AllServices = Mapper.Map<IEnumerable<ServiceViewModel>>(ServiceQueries.GetAllServicesView(userId)),
                    };
                    return View("Dashboard", servicesModel);
                }
            }
            return View("Preview");
        }

        /// <summary>
        /// Send a test Email to the current User
        /// </summary>
        public void TestEmail()
        {
            var gcNotify = new GcNotifyService(Configuration);

            gcNotify.SendTestEmail(User.FindFirstValue(ClaimTypes.Email));
        }

        /// <summary>
        /// To display a custom Error message 
        /// </summary>
        /// <param name="error">ErrorModel containing a Title and an Error message.</param>
        /// <returns></returns>
        [Route("Error")]
        public IActionResult Error(ErrorModel error)
        {
            return View(error);
        }

        /// <summary>
        /// To display an Error page to handle HTTP status codes
        /// </summary>
        /// <param name="code">HTTP status code</param>
        /// <returns></returns>
        [Route("Error/{code:int}")]
        public IActionResult Error()
        {
            return View();
        }
    }
}

WebClient/Controllers/ServicesController.cs
using AutoMapper;
using GoC.AppStatus.CheckService.Utilities;
using GoC.AppStatus.DBAccess.DBEntities;
using GoC.AppStatus.DBAccess.DataAccess;
using GoC.AppStatus.WebClient.Configs;
using GoC.AppStatus.WebClient.Models;
using GoC.WebTemplate.Components.Core.Services;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Localization;
using Microsoft.Extensions.Logging;
using System;
using System.Net;
using System.Security.Claims;
using System.Collections.Generic;

namespace GoC.AppStatus.WebClient.Controllers
{
    [Authorize]
    public class ServicesController : BaseController
    {
        private readonly IStringLocalizer<ServicesController> _localizer;
        private readonly IServiceQueries _serviceQueries;
        private readonly ISubscriptionQueries _subscriptionQueries;
        private readonly IUserQueries _userQueries;
        private readonly IEnvironmentQueries _environmentQueries;
        private IServiceQueries ServiceQueries => (IServiceQueries)ConnectDatabaseSQL(_serviceQueries);
        private IEnvironmentQueries EnvironmentQueries => (IEnvironmentQueries)ConnectDatabaseSQL(_environmentQueries);
        private ISubscriptionQueries SubscriptionQueries => (ISubscriptionQueries)ConnectDatabaseSQL(_subscriptionQueries);
        private readonly IServiceTester _serviceTester;
        public const string ErrorMsgCannotEdit = "You cannot edit this service, because you did not register it!";
        public const string ErrorMsgUrlExists = "The Url entered has already been added.";
        public const string ErrorMsgCannotRemove = "You cannot remove this service, because you did not register it!";
        public const string ErrorMsgUrlDoesntReturnValidResponse = "The Url entered doesn't return a valid response!";
        public const string ErrorMsgCannotSubscribe = "You cannot subscribe this service, because you did not register it!";
        public const string ErrorMsgCannotUnsubscribe = "You cannot unsubscribe this service, because you did not register it!";
        public const string ErrorMsgNameExists = "The name entered has already been added.";

        public ServicesController(ModelAccessor modelAccessor, 
                                  IMapper mapper, 
                                  IConfiguration configuration,
                                  ILogger<ServicesController> logger,
                                  IServiceQueries serviceQueries,
                                  ISubscriptionQueries subscriptionQueries,
                                  IUserQueries userQueries,
                                  IEnvironmentQueries environmentQueries,
                                  IStringLocalizer<BaseController> baseLocalizer,
                                  IStringLocalizer<ServicesController> localizer,
                                  IServiceTester serviceTester) :
            base(modelAccessor, mapper, configuration, logger, baseLocalizer)
        { 
            _localizer = localizer;
            _serviceQueries = serviceQueries;
            _subscriptionQueries = subscriptionQueries;
            _userQueries = userQueries;
            _environmentQueries = environmentQueries;
            _serviceTester = serviceTester;
        }

        public IActionResult Register()
        {
            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
            IEnumerable<EnvironmentModel> environmentModels = EnvironmentModel.GetAllEnvironments(EnvironmentQueries, Mapper, userId);
            ViewBag.Environments = environmentModels;

            return View();
        }

        [HttpPost]
        public IActionResult Register(ServiceModel model)
        {
            if (model == null) throw new System.Web.Http.HttpResponseException(HttpStatusCode.BadRequest);

            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);

            if (ModelState.IsValid)
            {
                model.Url = GetCanonicalUrl(model.Url);

                if (model.CheckForUrlDuplicate(ServiceQueries, userId))
                {
                    ModelState.AddModelError("Url", _localizer[ErrorMsgUrlExists]);
                }
            }

            if (ModelState.IsValid)
            {
                if (model.CheckForNameDuplicate(ServiceQueries, userId))
                {
                    ModelState.AddModelError("Url", _localizer[ErrorMsgNameExists]);
                }
            }

            if (ModelState.IsValid)
            {
                if (!model.Url.Equals(Configuration.GetValue<string>("BypassURLValidation:Url"), StringComparison.OrdinalIgnoreCase))
                {
                    var currentStatusCode = _serviceTester.GetStatusCode(new Uri(model.Url));
                    if (!_serviceTester.IsStatusCodeValid(currentStatusCode))
                    {
                        ModelState.AddModelError("Url", _localizer[ErrorMsgUrlDoesntReturnValidResponse]);
                    }
                }
            }

            if (ModelState.IsValid)
            {
                model.Add(ServiceQueries, Mapper, userId);
                return RedirectToAction("Index","Home");
            }
            else
            {
                IEnumerable<EnvironmentModel> environmentModels = EnvironmentModel.GetAllEnvironments(EnvironmentQueries, Mapper, userId);
                ViewBag.Environments = environmentModels;
                return View(model);
            }
        }

        public bool Subscribe(string serviceId)
        {
            if (serviceId == null) throw new System.Web.Http.HttpResponseException(HttpStatusCode.BadRequest);

            uint id = Convert.ToUInt32(serviceId, 10);

            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
            Service service = _serviceQueries.GetServiceById(id);
            ServiceModel.CheckIfUserAuthorizeToSubscribe(service, userId, ErrorMsgCannotSubscribe);

            var subscriptionId = SubscriptionQueries.GetSubscriptionIdFromServiceId(id);
            if (subscriptionId == 0)
            {
                // subscription record doesn't exist; create one:
                var subscription = new Subscription
                {
                    ServiceId = id,
                    UserId = userId,
                    SubscribedDatetime = DateTime.Now
                };
                return SubscriptionQueries.AddSubscription(subscription);
            }

            // update subscription record:
            return SubscriptionQueries.Subscribe(subscriptionId);
        }

        public bool Unsubscribe(string serviceId)
        {
            if (serviceId == null) throw new System.Web.Http.HttpResponseException(HttpStatusCode.BadRequest);

            uint id = Convert.ToUInt32(serviceId, 10);
            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
            Service service = _serviceQueries.GetServiceById(id);
            ServiceModel.CheckIfUserAuthorizeToUnsubscribe(service, userId, ErrorMsgCannotUnsubscribe);

            var subscriptionId = SubscriptionQueries.GetSubscriptionIdFromServiceId(id);
            if (subscriptionId == 0) throw new System.Web.Http.HttpResponseException(HttpStatusCode.BadRequest);
            return SubscriptionQueries.Unsubscribe(subscriptionId);
        }

        public IActionResult Edit(string id)
        {
            if (id == null) throw new System.Web.Http.HttpResponseException(HttpStatusCode.BadRequest);

            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
            Service service = _serviceQueries.GetServiceById(Convert.ToUInt32(id, 10));
            ServiceModel.CheckIfUserAuthorizeToEdit(service, userId, ErrorMsgCannotEdit);

            IEnumerable<EnvironmentModel> environmentModels = EnvironmentModel.GetAllEnvironments(EnvironmentQueries, Mapper, userId);
            ViewBag.Environments = environmentModels;

            var model = Mapper.Map<ServiceModel>(service);
            return View(model);
        }

        [HttpPost]
        public IActionResult Edit(string id, ServiceModel model)
        {
            if (id == null || model == null) throw new System.Web.Http.HttpResponseException(HttpStatusCode.BadRequest);

            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
            Service service = _serviceQueries.GetServiceById(Convert.ToUInt32(id, 10));
            ServiceModel.CheckIfUserAuthorizeToEdit(service, userId, ErrorMsgCannotEdit);

            if (ModelState.IsValid)
            {
                model.Url = GetCanonicalUrl(model.Url);

                var currentUrl = service.Url.ToString();
                if (currentUrl != model.Url && ServiceQueries.IsServiceUrlUsed(model.Url, userId))
                {
                    ModelState.AddModelError("Url", _localizer[ErrorMsgUrlExists]);
                }
            }

            if (ModelState.IsValid)
            {
                model.Update(Convert.ToUInt32(id, 10), ServiceQueries, Mapper);
                return RedirectToAction("Index", "Home");
            }
            else
            {
                IEnumerable<EnvironmentModel> environmentModels = EnvironmentModel.GetAllEnvironments(EnvironmentQueries, Mapper, userId);
                ViewBag.Environments = environmentModels;
                return View(model);
            }
        }

        public bool Remove(string id)
        {
            var userId = Convert.ToUInt32(User.FindFirstValue(CustomClaimTypes.Identifier), 10);
            Service service = _serviceQueries.GetServiceById(Convert.ToUInt32(id, 10));
            ServiceModel.CheckIfUserAuthorizeToRemove(service, userId, ErrorMsgCannotRemove);

WebClient/Views/Home/Dashboard.cshtml
@model GoC.AppStatus.WebClient.Models.DashboardViewModel

@using static GoC.AppStatus.WebClient.Tools;

@{
    var UserID = Context.User.FindFirst(GoC.AppStatus.WebClient.Configs.CustomClaimTypes.Identifier);
}

<h1>@Localizer["Dashboard"]</h1>
<p class="lead">@Localizer["Hello and Welcome! We have you registered as {0}.", Context.User.FindFirst(System.Security.Claims.ClaimTypes.Name).Value]</p>

<p>
    @Localizer["AppStatus is an application service to track the status of any other application, controlled by a web-application front end."]
    @Localizer["Anyone with a '@hrsdc - rhdcc.gc.ca' email can register an account to use the service."]
    @Localizer["Any user could then subscribe to any registered service."]
    @Localizer["By subscribing the user will receive an email notice any time the service is found to be non-responsive."]
</p>

<a id="testEmail"
   class="btn btn-info"
   asp-action="TestEmail"
   asp-controller="Home">
    @Localizer["Test Email Notification"]
</a>

@* Modal for TestEmail confirmation *@
<section id="testEmailConfirmation"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div class="modal-body">
        @Localizer["An email was sent to {0}.", @Context.User.FindFirst(System.Security.Claims.ClaimTypes.Email).Value]
    </div>
</section>

<h2>@Localizer["Registered Services"]</h2>

<!--Register Service button-->
<div class="btn-group mrgn-bttm-lg">
    <a class="btn btn-info"
       type="button"
       asp-action="Register"
       asp-controller="Services">
        @Localizer["Register a new Service"]
    </a>
</div>

<!--List of Services-->
<ul class="list-group">
    @{ 
        var httpClient = new System.Net.Http.HttpClient();
        GoC.AppStatus.CheckService.Utilities.ServiceTester tester = new GoC.AppStatus.CheckService.Utilities.ServiceTester(httpClient);
    }
    @foreach (var service in Model.AllServices) // AllServices: services created by the user
    {
        if (!service.DisabledDatetime.ToString().StartsWith("0001")) // service is removed
        {
            continue;
        }

        <li id="li_@service.Id" class="list-group-item">
            <div class="row">
                <div class="col-md-6">
                    <h3 class="list-group-item-heading">
                        @{
                            var currentStatusCode = tester.GetStatusCode(new Uri(service.Url.ToString()));
                            if (tester.IsStatusCodeValid(currentStatusCode))
                            {
                                <span style="color:limegreen; vertical-align: top;" class="glyphicon glyphicon-ok-sign"></span>
                            }
                            else
                            {
                                <span style="color:red; vertical-align: top;" class="glyphicon glyphicon-remove-sign"></span>
                            }
                        }
                        <strong>@service.Name</strong>
                        @if (service.envId != 0)
                        {
                            <span style="font-size: 80%; font-weight:normal; color: white; background: #@service.envColour;">&nbsp;@service.envTitle&nbsp;</span>
                        }
                        @if (service.Url.ToString().StartsWith("https", StringComparison.InvariantCultureIgnoreCase))
                        {
                            int certExpiryDays = service.CertExpiryDays;
                            string backColor = "";
                            string fontColor = "";
                            var sslMessage = Localizer[""];
                            if (certExpiryDays != int.MaxValue)
                            {

                                if (certExpiryDays <= 0)
                                {
                                    backColor = "red";
                                    fontColor = "white";
                                    sslMessage = Localizer["The SSL certificate expired {0} day(s) ago.", Math.Abs(certExpiryDays)];
                                }
                                else if (certExpiryDays <= 7)
                                {
                                    backColor = "orange";
                                    fontColor = "white";
                                    sslMessage = Localizer["The SSL certificate will expire in {0} day(s).", certExpiryDays];
                                }
                                else if (certExpiryDays <= 30)
                                {
                                    backColor = "yellow";
                                    fontColor = "gray";
                                    sslMessage = Localizer["The SSL certificate will expire in {0} day(s).", certExpiryDays];
                                }
                                <span style="padding:5px; font-size: 50%; vertical-align: middle; font-weight: normal; color: @fontColor; background-color: @backColor; ">@sslMessage</span>
                            }
                        }
                    </h3>

                    <p class="list-group-item-text">
                        <a href="@service.Url"
                           target="_blank">
                            @service.Url
                        </a>
                    </p>
                </div>

                <div class="col-md-6">
                    <div class="btn-group pull-right">
                        <a class="btn btn-default"
                           type="button"
                           asp-action="Edit"
                           asp-route-id="@service.Id.ToString()"
                           asp-controller="Services">
                            @Localizer["Edit"]
                        </a>

                        <button id="btn_subscribe_@service.Id"
                                style="@(service.Subscribed ? "display:none" : "display:block")"
                                value="@service.Id"
                                class="btn btn-default subscribe">
                            @Localizer["Subscribe"]
                        </button>

                        <button id="btn_unsubscribe_@service.Id"
                                style="@(service.Subscribed ? "display:block" : "display:none")"
                                value="@service.Id"
                                class="btn btn-default unsubscribe">
                            @Localizer["Unsubscribe"]
                        </button>

                        <button value="@service.Id,@service.Name"
                                class="btn btn-default remove">
                            @Localizer["Remove"]
                        </button>
                    </div>
                </div>
            </div>
        </li>
    }
</ul>

@* Modal for confirmation of removing service *@
<section id="removeServiceConfirmation"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div class="modal-body">
        <p id="removeServiceConfirmationMsg"></p>
        <button id="btnremoveServiceConfirmation" class="btn btn-default popup-modal-dismiss" onclick="RemoveService(this.val);">
            @Localizer["Yes"]
        </button>
        <button class="btn btn-default popup-modal-dismiss">
            @Localizer["No"]
        </button>
    </div>
</section>

@* Modal for result of subscribing/removing service (success or error) *@
<section id="subscribedRemovedService"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div id="divSubscribedRemovedService" class="modal-body">
    </div>
</section>

@section CustomScripts {
    <script>

        //Ajax function to call TestEmail without leaving the page
        $("#testEmail").click(function (e) {
            e.preventDefault();
            $.ajax({
                url: "Home/TestEmail",
                success: function () {
                    $(document).trigger("open.wb-lbx", [[{ src: "#testEmailConfirmation", type: "inline" }]]);
                }
            });
        });

        // Ajax function to call Subscribe method:
        $(".subscribe").on('click', function () {
            SubscribeUnsubscribe($(this).val(), true);
        });

        // Ajax function to call Unsubscribe method:
        $(".unsubscribe").on('click', function () {
            SubscribeUnsubscribe($(this).val(), false);
        });

        // function to subscribe/unsubscribe service:
        function SubscribeUnsubscribe(serviceId, subscribe) {
            var data = { "serviceId": serviceId };
            if (subscribe) var url = "/Services/Subscribe"; else var url = "/Services/Unsubscribe";
            $.ajax({
                url: url,
                data: data,
                success: function (result) {
                    if (result) {
                        if (subscribe) {
                            document.getElementById('btn_subscribe_' + serviceId).style.display = "none";
                            document.getElementById('btn_unsubscribe_' + serviceId).style.display = "block";
                            var msg = '@Localizer["Service has been subscribed."]';
                        }
                        else {
                            document.getElementById('btn_subscribe_' + serviceId).style.display = "block";
                            document.getElementById('btn_unsubscribe_' + serviceId).style.display = "none";
                            var msg = '@Localizer["Service has been unsubscribed."]';
                        }
                    }
                    else {
                        if (subscribe) var msg = '@Localizer["An error occurred during service subscribing!"]';
                        else msg = '@Localizer["An error occurred during service unsubscribing!"]';
                    }
                    document.getElementById("divSubscribedRemovedService").innerHTML = msg;
                    $(document).trigger("open.wb-lbx", [[{ src: "#subscribedRemovedService", type: "inline" }]]);
                }
            });
        }

        // Ajax call to remove service (confirmation required):
        $(".remove").on('click', function () {
            var array = $(this).val().split(',');
            var id = array[0];
            var name = array[1];
            var msg = '@Localizer["Are you sure you want to delete the service named"]' + ' "' + name + '"?<br /><br />';
            msg += '@Localizer["Warning: this action can not be undone!"]' + '<br /><br />';
            document.getElementById("removeServiceConfirmationMsg").innerHTML = msg;
            document.getElementById("btnremoveServiceConfirmation").val = id;
            $(document).trigger("open.wb-lbx", [[{ src: "#removeServiceConfirmation", type: "inline" }]]);
            return;
        });

        // Ajax call to remove service (after user has confirmed removing):
        function RemoveService(id) {
            var data = { "id": id };
            $.ajax({
                url: "/Services/Remove",
                data: data,
                success: function (result) {
                    if (result) {
                        document.getElementById('li_' + id).style.display = "none";
                        msg = '@Localizer["Service has been removed."]';
                    }
                    else {
                        msg = '@Localizer["An error occurred during service removing!"]';
                    }
                    document.getElementById("divSubscribedRemovedService").innerHTML = msg;
                    $(document).trigger("open.wb-lbx", [[{ src: "#subscribedRemovedService", type: "inline" }]]);
                }
            });
        }
    </script>
}

WebClient/Views/Home/Preview.cshtml
@model IEnumerable<GoC.AppStatus.WebClient.Models.ServiceViewModel>

<h1>@Localizer["Dashboard"]</h1>
<p class="lead">@Localizer["Hello and Welcome! You are not logged in."]</p>

<p>
    @Localizer["AppStatus is an application service to track the status of any other application, controlled by a web-application front end."]
    @Localizer["Anyone with a '@hrsdc - rhdcc.gc.ca' email can register an account to use the service."]
    @Localizer["Any user could then subscribe to any registered service."]
    @Localizer["By subscribing the user will receive an email notice any time the service is found to be non-responsive."]
</p>